<?php
//  Program: MySQLi_Functions.php
//  Purpose: Pretty Table Dump
//  Created: 03-05-2015 Kirk Hopkins
echo '<style>';
echo '.TheList table { table-layout: fixed; }';
echo '.TheList tr:nth-child(even) { background: #EFEFEF; }';
echo '.TheList tr:nth-child(odd) { background: #DEDEDE; }';
echo '.TheList td { padding:3px; border: 1px solid #343434; width:150px; }';
echo '.QueryBox { background: #cdcdcd; padding:10px; margin: 0px 10px 20px 10px; }';
echo '.InfoBox { background: #898989; padding:10px; margin:2px; color: #EFEFEF; }';
echo '.TimeBox { background: #676767; padding:10px; margin:2px; color: #DEDEDE; }';
echo '</style>';

function ListTable($link,$sql){
  echo '<div class="QueryBox">Query:<br><PRE>'.$sql.'</PRE>';
  $msc = microtime(true);
  if($result=mysqli_query($link,$sql)){
    $numcols = mysqli_num_fields($result);
    echo '<div class="InfoBox">Found <b>'.mysqli_num_rows($result).'</b> rows and <b>'.$numcols.'</b> columns.</div>'."\n";
    echo '<table class="TheList">';
    echo '<tr><td style="vertical-align: bottom;">row</td>';
    // Get field name, type, and length
    while($fieldinfo=mysqli_fetch_field($result)){
      echo '<td>';
      echo '<b>'.$fieldinfo->name.'</b>';
      echo '<br><i>'.strtolower(number_to_text($fieldinfo->type)).'</i>'; //echo '<br>'.$fieldinfo->type;
      echo '<br><i>max length: '.$fieldinfo->max_length.'</i>';
      echo '</td>';
    }
    echo '</tr>';
    // Loop through the results of the query
    for ($row = 0;$row < mysqli_num_rows($result);$row++) {
      $getarow = mysqli_fetch_row($result);
   	  echo '<tr><td>'.($row+1).'</td>'; // record number
   	  for ($col= 0; $col < $numcols;$col++) {
        echo '<td>';
        echo $getarow[$col];
   	    echo '</td>';
   	  }
   	  echo '</tr>';
   	}
    echo '</table>';
    $msc = microtime(true)-$msc;
    if($msc>.0000000001){
      echo '<div class="TimeBox">Query run time (in seconds): <b>'.$msc.'</b></div>';
    }
    echo '</div>';  
    mysqli_free_result($result); // Free result set
  }
  
}
function number_to_text($type_id){
  //Change a field type number to words (i.e. 253 will display as VAR_STRING)
  static $types;
  if(!isset($types)){
    $types = array();
    $constants = get_defined_constants(true);
    foreach ($constants['mysqli'] as $c => $n) if (preg_match('/^MYSQLI_TYPE_(.*)/', $c, $m)) $types[$n] = $m[1];
  }
  return array_key_exists($type_id, $types)? $types[$type_id] : NULL;
}
?>