<?php
//  Program: SQLfun.php
//  Purpose: Create tables, insert records, and do selects to show how a relational database works
//  Created: 03-05-2015 Kirk Hopkins
//           ListTable Calls a function in MySQL_PrettyTable.php to show a pretty table dump
?>
<!doctype html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <title>SQLfun by Kirk Hopkins</title>
</head>
<body>
  <h1>SQL fun</h1>
  <?php
  require_once("Connect_to_Database.php"); // one line to add to each program instead of many
  require_once("MySQL_PrettyTable.php"); // one line to add to each program instead of many 
  echo '<style>';
  echo '.SectionTitle { background: #676767; padding:10px;margin:60px 10px 0px 10px; color: #DEDEDE;}';
  echo '</style>';
  $Knowntimestamp=date('Y-m-d H:i:s'); //timestamp format Year-month-day hours:minutes:seconds
  $StartOver='';
  //$StartOver='yup';
  $ThisManyPeople=1000000;
  //Time to create the tables and insert 1 million records (*2) (in seconds): 316.669425964
  if($StartOver=='yup'){
    $msc = microtime(true); //start the clock to see how long this takes
    
    //Command to drop (delete) a table
    $TableName='people';
    $sql ="DROP TABLE ".$TableName."";
    if ($link->query($sql) === TRUE) {
      echo "Table ".$TableName." dropped successfully<br>";
    } else {
      echo "Error dropping table: ".$link->error.'<br>';
    }
    //Command to create a new table
    $sql ="CREATE TABLE ".$TableName." (
    `key` int NOT NULL AUTO_INCREMENT,
      `person_id` varchar(255) NOT NULL,
      `first_name` varchar(255) NOT NULL,
      `last_name` varchar(255) NOT NULL,
      `gender` varchar(255) NOT NULL,
      `time_created` timestamp NOT NULL,
      `time_removed` timestamp NOT NULL,
      PRIMARY KEY(`key`)
    ) ENGINE=InnoDB DEFAULT CHARSET=latin1;";
    if ($link->query($sql) === TRUE) {
      echo "Table ".$TableName." created successfully<br>";
      
      $sql ="CREATE INDEX people_person_id ON ".$TableName." (person_id)";
      if ($link->query($sql) === TRUE) {
        echo "Index ".$TableName." created successfully<br>";
      } else {
        echo "Did NOT create index: : ".$link->error.'<br>';
      }
    } else {
      echo "Did NOT create table: : ".$link->error.'<br>';
    }
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'1000000001','Bob', 'Doe', 'M','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'1000000002','Tom', 'Moe', 'M','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'1000000003','Sally', 'Sue', 'F','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'1000000004','Jane', 'Doe', 'M','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'1000000005','Jimmy', 'John', 'M','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'1000000006','Jack', 'Smith', 'M','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'1000000007','Jill', 'Smith', 'F','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'1000000008','Cindy', 'Smith', 'F','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    for ($row = 0;$row < $ThisManyPeople;$row++) {
      set_time_limit(3200);//reset the time limit in case we're doing a ton of records
      $id=(1000000100+$row); // make id's
      $zero_or_one=rand(0,1); // generate a random 0 or 1 to set the gender later
      if($zero_or_one=='0'){
        $gender='M';
      } else {
        $gender='F';
      }
      $SemiRandomDate=date('Y-m-d H:i:s',mktime(rand(0,24),rand(0,60),rand(0,60),rand(1,12),rand(1,31),rand(1999,2004)));
      //mktime(hours,minutes,seconds,month,day,year)
      $insert = "INSERT INTO ".$TableName." (`key`,person_id,first_name,last_name,gender,time_created) VALUES (NULL,'".$id."','FirstNameFor".$id."', 'LastNameFor".$id."', '".$gender."','$SemiRandomDate');";$result = mysqli_query($link,$insert);  
    }

    //Command to drop (delete) a table
    $TableName='group_cross_reference';
    $sql ="DROP TABLE ".$TableName."";
    if ($link->query($sql) === TRUE) {
      echo "Table ".$TableName." dropped successfully<br>";
    } else {
      echo "Error dropping table: ".$link->error.'<br>';
    }
    //Command to create a new table
    $sql ="CREATE TABLE ".$TableName." (
    `key` int NOT NULL AUTO_INCREMENT,
      `group_id` varchar(255) NOT NULL,
      `group_name` varchar(255) NOT NULL,
      `time_created` timestamp NOT NULL,
      `time_removed` timestamp NOT NULL,
      PRIMARY KEY(`key`)
    ) ENGINE=InnoDB DEFAULT CHARSET=latin1;";
    if ($link->query($sql) === TRUE) {
      echo "Table ".$TableName." created successfully<br>";

      $sql ="CREATE INDEX group_cross_reference_group_id ON ".$TableName." (group_id)";
      if ($link->query($sql) === TRUE) {
        echo "Index ".$TableName." created successfully<br>";
      } else {
        echo "Did NOT create index: : ".$link->error.'<br>';
      }
    } else {
      echo "Did NOT create table: : ".$link->error.'<br>';
    }
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'990','Lonely Group', '$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'991','Musician', '$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'992','Artist', '$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'993','Scientist', '$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'994','Computer Programmer', '$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'995','Magician', '$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'996','Chef', '$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'997','Good Speller', '$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,group_id,group_name,time_created) VALUES (NULL,'998','Bad Speler', '$Knowntimestamp');";$result = mysqli_query($link,$insert);

    //Command to drop (delete) a table
    $TableName='designations';
    $sql ="DROP TABLE ".$TableName."";
    if ($link->query($sql) === TRUE) {
      echo "Table ".$TableName." dropped successfully<br>";
    } else {
      echo "Error dropping table: ".$link->error.'<br>';
    }
    //Command to create a new table
    $sql ="CREATE TABLE ".$TableName." (
    `key` int NOT NULL AUTO_INCREMENT,
      `person_id` varchar(255) NOT NULL,
      `group_id` varchar(255) NOT NULL,
      `time_created` timestamp NOT NULL,
      `time_removed` timestamp NOT NULL,
      PRIMARY KEY(`key`)
    ) ENGINE=InnoDB DEFAULT CHARSET=latin1;";
    if ($link->query($sql) === TRUE) {
      echo "Table ".$TableName." created successfully<br>";
      
      $sql ="CREATE INDEX designations_person_id ON ".$TableName." (person_id)";
      if ($link->query($sql) === TRUE) {
        echo "Index ".$TableName." created successfully<br>";
      } else {
        echo "Did NOT create index: : ".$link->error.'<br>';
      }
      $sql ="CREATE INDEX designations_group_id ON ".$TableName." (group_id)";
      if ($link->query($sql) === TRUE) {
        echo "Index ".$TableName." created successfully<br>";
      } else {
        echo "Did NOT create index: : ".$link->error.'<br>';
      }
    } else {
      echo "Did NOT create table: : ".$link->error.'<br>';
    }

    $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'1000000001','991','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'1000000001','992','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'1000000001','993','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'1000000002','991','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'1000000002','993','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'1000000003','991','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'1000000003','992','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'1000000006','994','$Knowntimestamp');";$result = mysqli_query($link,$insert);
    for ($row = 0;$row < $ThisManyPeople;$row++) {
      set_time_limit(3200);//reset the time limit in case we're doing a ton of records
      $id=(1000000100+$row); // make designations for some of the id's
      $RandomGroupNumber=rand(990,998); // generate a random 0 or 1 to set the gender later
      if($RandomGroupNumber<'991'){
        //skip it
      } else {
        $SemiRandomDate=date('Y-m-d H:i:s',mktime(rand(0,24),rand(0,60),rand(0,60),rand(1,12),rand(1,31),rand(2005,2014)));
        $insert = "INSERT INTO ".$TableName." (`key`,person_id,group_id,time_created) VALUES (NULL,'".$id."','".$RandomGroupNumber."', '$SemiRandomDate');";$result = mysqli_query($link,$insert);  
      }
    }
    
    $msc = microtime(true)-$msc;
    echo '<div class="TimeBox">Time to create the tables and insert records (in seconds): <b>'.$msc.'</b></div>';
    //exit;
  }
  
  //Are indexes important?  You tell me...
  //10000ish records
  //With indexes -> Time to create the tables and insert records (in seconds): 3.31597495079
  //Without indexes -> Time to create the tables and insert records (in seconds): 3.35210800171 //not for record inserts
  
  //People with all of the groups they are in (if any), this will be a wide table:
  // with indexes -> Query run time (in seconds): 0.620235919952
  // without indexes -> Query run time (in seconds): 214.159296989 //yes, can't live without them
  
  $tableName='people';
  echo '<div class="SectionTitle">Records in the <b>'.$tableName.'</b> table:</div>';
  $sql="select *
          from $tableName
         limit 99999";
  ListTable($link,$sql);

  $tableName='group_cross_reference';
  echo '<div class="SectionTitle">Records in the <b>'.$tableName.'</b> table:</div>';
  $sql="select *
          from $tableName
         limit 99999";
  ListTable($link,$sql);

  $tableName='designations';
  echo '<div class="SectionTitle">Records in the <b>'.$tableName.'</b> table:</div>';
  $sql="select *
          from $tableName
         limit 99999";
  ListTable($link,$sql);

  echo '<div class="SectionTitle">Show the group name for each person in a group (a person may appear more than once):</div>';
  $sql="select people.person_id
               ,people.first_name
               ,people.last_name
               ,people.gender
               ,group_cross_reference.group_name
          from people, group_cross_reference, designations
         where people.person_id = designations.person_id
               and group_cross_reference.group_id = designations.group_id
      order by people.last_name,people.first_name
         limit 99999";
  ListTable($link,$sql);

  echo '<div class="SectionTitle">Same query as before but using an alias for the table names - Show the group name for each person in a group:</div>';
  $sql="select p.person_id
               ,p.first_name
               ,p.last_name
               ,p.gender
               ,g.group_name
          from people p, group_cross_reference g, designations d
         where p.person_id = d.person_id
               and g.group_id = d.group_id
      order by p.last_name,p.first_name
         limit 99999";
  ListTable($link,$sql);

  echo '<div class="SectionTitle">People that are not in any group:</div>';
  $sql="select p.person_id
               ,p.first_name
               ,p.last_name
               ,p.gender
          from people p
         where p.person_id not in (select designations.person_id
                                     from designations
                                    where p.person_id=designations.person_id
                                  )
      order by p.last_name,p.first_name
         limit 99999";
  ListTable($link,$sql);

  echo '<div class="SectionTitle">Groups without any people:</div>';
  $sql="select g.group_name
          from group_cross_reference g
         where g.group_id not in (select d.group_id
                                    from designations d
                                 )
      order by g.group_name
         limit 99999";
  ListTable($link,$sql);

  $Musician="
              CASE WHEN (
                         (select count(*)
                            from designations, group_cross_reference
                           where p.person_id = designations.person_id
                                 and group_cross_reference.group_id = designations.group_id
                                 and group_cross_reference.group_name = 'Musician'
                         ) < 1
                        ) THEN
                          NULL
                          ELSE
                         (select group_cross_reference.group_name
                            from designations, group_cross_reference
                           where p.person_id = designations.person_id
                                 and group_cross_reference.group_id = designations.group_id
                                 and group_cross_reference.group_name = 'Musician'
                           limit 1
                         )
                        END
              as Musician";
  //Little bit different way to do the else since we know what we're looking for
  $Scientist="
              CASE WHEN (
                         (select count(*)
                            from designations, group_cross_reference
                           where p.person_id = designations.person_id
                                 and group_cross_reference.group_id = designations.group_id
                                 and group_cross_reference.group_name = 'Scientist'
                         ) < 1
                        ) THEN
                          NULL
                          ELSE
                         'Scientist'
                        END
              as Scientist";

  echo '<div class="SectionTitle">People with some of the groups they are in (if any), this will be a wide table:</div>';
  $sql="select p.person_id
               ,p.first_name
               ,p.last_name
               ,p.gender
               ,$Musician
               ,$Scientist
          from people p
         where p.person_id
      order by p.last_name,p.first_name
         limit 99999";
  ListTable($link,$sql);
  
  echo '<div class="SectionTitle">People with all of the groups they are in (if any), this will be a wide table:</div>';
  ////Let's get really fancy by dynamically creating a case for every group by doing a select on the table and looping 
  ////through to generate our sql to use later
  $AdditionalFieldsToInclude='';
  $group_name='';
  $sql="select distinct group_name
              from group_cross_reference
          order by group_cross_reference.group_name
           ";
  if($result=mysqli_query($link,$sql)){
    while ($row = mysqli_fetch_assoc($result)){
   	  //echo $row['group_name'].'<br>';
      $LabelFound=$row['group_name'];
      $ThisVariable=str_replace('/','',$LabelFound);
      $ThisVariable=str_replace(',','',$ThisVariable);
      $ThisVariable=str_replace('-','',$ThisVariable);
      $ThisVariable=str_replace('&','',$ThisVariable);
      $ThisVariable=str_replace('(','',$ThisVariable);
      $ThisVariable=str_replace(')','',$ThisVariable);
      $DisplayVariableName=$ThisVariable;
      $LabelFoundSQL=stripslashes($LabelFound);
      $ThisOne=",
        CASE WHEN ((select count(*)
                      from designations, group_cross_reference
                     where group_cross_reference.group_name = '$LabelFoundSQL'
                           and p.person_id = designations.person_id
                           and group_cross_reference.group_id = designations.group_id
                   ) <1
                  ) THEN
          NULL
        ELSE
          (select group_cross_reference.group_name
                      from designations, group_cross_reference
                     where group_cross_reference.group_name = '$LabelFoundSQL'
                           and p.person_id = designations.person_id
                           and group_cross_reference.group_id = designations.group_id
                     limit 1)
        END
          as ".strtolower(str_replace(' ','_',$DisplayVariableName));
      $AdditionalFieldsToInclude.=$ThisOne;
    }
  }
  $sql="select p.person_id
               ,p.first_name
               ,p.last_name
               ,p.gender
               $AdditionalFieldsToInclude
          from people p
         where p.person_id<>''
      order by p.last_name,p.first_name
         limit 99999";
  ListTable($link,$sql);
  
  echo '<div class="SectionTitle">Total number of people in a group broken down by gender (only counts each person once even if they are in more than one group):</div>';
  $sql="select count(*) as number_of_people, p.gender
          from people p
         where p.person_id in (select d.person_id
                                 from designations d
                              )  
      group by p.gender
      order by p.gender
         limit 11111111";
  ListTable($link,$sql);
  ?>
</body>
</html>